﻿-- (c) eradicator a.k.a lossycrypt, 2017-2021, not seperately licensable
-- -------------------------------------------------------------------------- --

--[[ Notes:
  ]]

--[[ Annecdotes:
  ]]

--[[ Future:
  ]]
  
--[[ Todo:
  ]]
  
-- -------------------------------------------------------------------------- --
-- Built-In                                                                   --
-- -------------------------------------------------------------------------- --
local elroot = (pcall(require,'erlib/empty')) and '' or '__eradicators-library__/'
local say,warn,err,elreq,flag,ercfg=table.unpack(require(elroot..'erlib/shared'))

-- -------------------------------------------------------------------------- --
-- Eradicators Library                                                        --
-- (Factorio does not allow runtime require!)                                 --
-- -------------------------------------------------------------------------- --
local log         = elreq('erlib/lua/Log'          )().Logger  'stockpile-2-infinity-ticker'
-- local stop        = elreq('erlib/lua/Error'        )().Stopper 'stockpile-2'
-- local assertify   = elreq('erlib/lua/Error'        )().Asserter(stop)

-- local Verificate  = elreq('erlib/lua/Verificate'   )()
-- local verify      = Verificate.verify
-- local isType      = Verificate.isType

local Table       = elreq('erlib/lua/Table'        )()
local Array       = elreq('erlib/lua/Array'        )()
local Set         = elreq('erlib/lua/Set'          )()
-- local Filter      = elreq('erlib/lua/Filter'       )()
-- local Vector      = elreq('erlib/lua/Vector'       )()

-- local ntuples     = elreq('erlib/lua/Iter/ntuples' )()
-- local dpairs      = elreq('erlib/lua/Iter/dpairs'  )()
-- local sriapi      = elreq('erlib/lua/Iter/sriapi'  )()

-- local Setting     = elreq('erlib/factorio/Setting'   )()
-- local Player      = elreq('erlib/factorio/Player'    )()
-- local getp        = Player.get_event_player

local math_min
    = math.min

-- -------------------------------------------------------------------------- --
-- Constants                                                                  --
-- -------------------------------------------------------------------------- --
local script = EventManager .get_managed_script    'stockpile-2-infinity-ticker'
local import = PluginManager.make_relative_require 'stockpile-2'
local const  = import '/const'
local Local  = const.Local
local index  = const.index

-- local StockpileGui = import '/control/StockpileGui'
-- local Stockpile    = import '/control/Stockpile'

-- -------------------------------------------------------------------------- --
-- Module                                                                     --
-- -------------------------------------------------------------------------- --
local InfinityTicker = {}

-- -------------------------------------------------------------------------- --
-- Local Library                                                              --
-- -------------------------------------------------------------------------- --

local function add(tbl, key, value)
  tbl[key] = tbl[key] + value
  end

-- -------------------------------------------------------------------------- --
-- Savedata                                                                   --
-- -------------------------------------------------------------------------- --
local Savedata
PluginManager.manage_savedata('stockpile-2', function(_) Savedata = _ end)
  
-- -------------------------------------------------------------------------- --
-- Class                                                                      --
-- -------------------------------------------------------------------------- --

function InfinityTicker.is_registered(pile)
  local infinities = Savedata.ticked_arrays.infinities
  if infinities ~= nil then
    for i=1, infinities.n do if infinities[i] == pile then return true end end
    end
  return false end

function InfinityTicker.add_pile(pile)
  local infinity = assert(pile[index.pile.infinity])
  -- InfinityTicker.cache_inventory_methods(pile)
  InfinityTicker.cache_inventory(pile)
  if not InfinityTicker.is_registered(pile) then
    table.insert(InfinityTicker.sget_infinities(), pile)
    InfinityTicker.repair_infinities()
    end
  end
  
function InfinityTicker.remove_pile(pile)
  -- assert(nil == pile[index.pile.infinity])
  Array.unsorted_remove_value(InfinityTicker.sget_infinities(), pile)
  InfinityTicker.repair_infinities()
  end

function InfinityTicker.sget_infinities()
  return Table.sget(Savedata, {'ticked_arrays', 'infinities'}, {n = 0})
  end
  
function InfinityTicker.get_infinities()
  return Savedata.ticked_arrays.infinities
  end
  
function InfinityTicker.repair_infinities()
  local infinities = Savedata.ticked_arrays.infinities
  if infinities ~= nil then
    infinities.n = #infinities
    if infinities.n <= 0 then
      Savedata.ticked_arrays.infinities = nil
      end
    end
  log:debug('infinities repaired')
  InfinityTicker.register_handlers()
  end
  
  
-- Fixes a bug that added the same pile multiple times.
function InfinityTicker.deduplicate_infinities()
  local infinities = Savedata.ticked_arrays.infinities
  if infinities ~= nil then
    local n = infinities.n
    local seen = {}
    for i = infinities.n, 1, -1 do
      local pile = infinities[i]
      
      if seen[pile] then
        Array.shuffle_pop(infinities, i)
        log:warn('Duplicate pile removed.')
        end
      seen[pile] = true
      end
    
  
    -- InfinityTicker.remove_pile(pile)
    -- InfinityTicker.add_pile(pile)
    -- end
    
    InfinityTicker.repair_infinities()
    log:debug('infinities deduplicated: ', n, ' → ', infinities.n)
    
    end
  end
  
  
-- -- V1: crashes?
-- function InfinityTicker.cache_inventory_methods(pile)
--   local infinity  = assert(pile[index.pile.infinity])
--   local container = pile[index.pile.container]
--   local inventory = container.get_inventory(defines.inventory.chest)
--   infinity.remove         = inventory.remove        
--   infinity.insert         = inventory.insert        
--   infinity.get_item_count = inventory.get_item_count
--   end
-- 
-- -- V2: works? nope
-- function InfinityTicker.cache_inventory_methods(pile)
--   local infinity  = assert(pile[index.pile.infinity])
--   local container = pile[index.pile.container]
--   local inventory = container.get_inventory(defines.inventory.chest)
--   --
--   infinity.remove         = nil
--   infinity.insert         = nil
--   infinity.get_item_count = nil
--   --
--   setmetatable(infinity, {__index = {
--     remove         = inventory.remove        ,
--     insert         = inventory.insert        ,
--     get_item_count = inventory.get_item_count,
--     }})
--   end
  
-- V3
function InfinityTicker.cache_inventory(pile)
  local infinity = pile[index.pile.infinity]
  if infinity then
    -- Can't use pile:get_inventory() without making Stockpile global
    -- due to recursive dependency. "pile" does not have meta during on_load.
    infinity[index.infinity.inventory]
      = pile[index.pile.container].get_inventory(defines.inventory.chest)
    end
  end
  
  
-- -------------------------------------------------------------------------- --
-- Events                                                                     --
-- -------------------------------------------------------------------------- --

function InfinityTicker.register_handlers()
  if Savedata.ticked_arrays.infinities == nil then
    script.on_event(defines.events.on_tick, nil)
  else
    assert(Savedata.ticked_arrays.infinities.n > 0)
    script.on_event(defines.events.on_tick, InfinityTicker.on_tick)
    end
  log:debug('handlers registered')
  end

script.on_load(function()
  InfinityTicker.register_handlers()
  --
  for _, pile in ipairs(Savedata.stockpiles) do
    local infinity = pile[index.pile.infinity]
    -- if infinity then InfinityTicker.cache_inventory_methods(pile) end
    if infinity then InfinityTicker.cache_inventory(pile) end
    end
  end)


-- -------------------------------------------------------------------------- --
  
  
script.on_config(function()
  InfinityTicker.deduplicate_infinities()
  end)
  
  
-- -------------------------------------------------------------------------- --

  
-- The count of ticks between two updates of the same pile.
-- Each pile is updated *exactly* this often. CPU usage scales
-- with pile count.
local update_intervall = 60

function InfinityTicker.on_tick(e)
  local infinities = InfinityTicker.get_infinities()
  for i = infinities.n - (e.tick % update_intervall), 1, -update_intervall do
    -- print(e.tick, infinities.n, i)
    local pile = infinities[i]
    --
    -- remove invalid?
    if not pile[index.pile.container].valid then
      InfinityTicker.remove_pile(pile)
    --
    -- manage inventory
    else
      --
      local infinity     = pile[index.pile.infinity]
      --
      local inventory    = infinity[index.infinity.inventory]
      local simple_stack = infinity[index.infinity.simple_stack]
      local half_count   = infinity[index.infinity.half_count]
      --
      local count        = inventory.get_item_count(simple_stack.name)
      add(infinity, index.infinity.total_count, count)
      
      -- real -> virtual
      if count > half_count then
        simple_stack.count = count - half_count
        add(infinity, index.infinity.stored_count, inventory.remove(simple_stack))
      
      -- virtual -> real
      elseif count < half_count then
        local stored_count = infinity[index.infinity.stored_count]
        if stored_count > 0 then -- "Stack count has to be positive integer"
          simple_stack.count = math_min( half_count - count, stored_count)
          add(infinity, index.infinity.stored_count, -inventory.insert(simple_stack))
          end
        end
      end
    end
  end

  
-- -------------------------------------------------------------------------- --

return InfinityTicker