﻿-- (c) eradicator a.k.a lossycrypt, 2017-2021, not seperately licensable
-- -------------------------------------------------------------------------- --

--[[ Notes:
  ]]

--[[ Annecdotes:
  ]]

--[[ Future:
  ]]
  
--[[ Todo:
  ]]
  
-- -------------------------------------------------------------------------- --
-- Built-In                                                                   --
-- -------------------------------------------------------------------------- --
local elroot = (pcall(require,'erlib/empty')) and '' or '__eradicators-library__/'
local say,warn,err,elreq,flag,ercfg=table.unpack(require(elroot..'erlib/shared'))

-- -------------------------------------------------------------------------- --
-- Eradicators Library                                                        --
-- (Factorio does not allow runtime require!)                                 --
-- -------------------------------------------------------------------------- --
-- local log         = elreq('erlib/lua/Log'          )().Logger  'template'
-- local stop        = elreq('erlib/lua/Error'        )().Stopper 'template'
-- local assertify   = elreq('erlib/lua/Error'        )().Asserter(stop)

-- local Verificate  = elreq('erlib/lua/Verificate'   )()
-- local verify      = Verificate.verify
-- local isType      = Verificate.isType

local Table       = elreq('erlib/lua/Table'        )()
-- local Array       = elreq('erlib/lua/Array'        )()
-- local Set         = elreq('erlib/lua/Set'          )()
-- local Filter      = elreq('erlib/lua/Filter'       )()
-- local Vector      = elreq('erlib/lua/Vector'       )()
local Class       = elreq('erlib/lua/Class'        )()

-- local ntuples     = elreq('erlib/lua/Iter/ntuples' )()
-- local dpairs      = elreq('erlib/lua/Iter/dpairs'  )()
-- local sriapi      = elreq('erlib/lua/Iter/sriapi'  )()

-- local Setting     = elreq('erlib/factorio/Setting'   )()
local Cache       = elreq('erlib/factorio/Cache'     )()
local Player      = elreq('erlib/factorio/Player'    )()
-- local getp        = Player.get_event_player

-- -------------------------------------------------------------------------- --
-- Constants                                                                  --
-- -------------------------------------------------------------------------- --
local script = EventManager .get_managed_script    'stockpile-2'
local import = PluginManager.make_relative_require 'stockpile-2'
local const  = import '/const'
local Local  = const.Local
local index  = const.index

local StockpileGui = import '/control/StockpileGui'
local InfinityTicker = import '/control/InfinityTicker'


-- -------------------------------------------------------------------------- --
-- Module                                                                     --
-- -------------------------------------------------------------------------- --
local Stockpile = {}


-- -------------------------------------------------------------------------- --
-- Savedata                                                                   --
-- -------------------------------------------------------------------------- --
local Savedata
PluginManager.manage_savedata('stockpile-2', function(_) Savedata = _ end)
  
-- -------------------------------------------------------------------------- --
-- Local Library                                                              --
-- -------------------------------------------------------------------------- --

local function assert_valid_entity_wrapper(entity)
  assert(entity.object_name == 'LuaEntity')
  assert(entity.valid)
  return true end

  
  
-- local is_infinity_allowed_item; do
  -- local _names = Cache.AutoCache(function(r)
    -- for name in pairs(game.get_filtered_item_prototypes(
      -- const.stockpile.infinity.ItemPrototypeFilter
      -- )) do r[name] = true end
    -- end)
  
  -- is_infinity_allowed_item = function(name) return true == _names[name] end
  -- end
  
local infinity_items = Cache.AutoCache(function(r)
  for name, prot in pairs(game.get_filtered_item_prototypes(
  const.stockpile.infinity.ItemPrototypeFilter
  )) do
    r[name] = {stack_size = prot.stack_size}
    end
  end)
  
  
-- -------------------------------------------------------------------------- --
-- Events                                                                     --
-- -------------------------------------------------------------------------- --


local Stockpile = Class.SimpleClass(
  --
  function(entity)
    if entity then
      assert_valid_entity_wrapper(entity)
      if Local.is_stockpile_name(entity.name) then
        local uid  = entity.unit_number
        local pile = Table.sget(Savedata.stockpiles, {uid}, {})
        pile[index.pile.container] = entity
        return pile end
      end
    end,
  --
  function(pile)
    end
  )
  
  
-- -------------------------------------------------------------------------- --

function Stockpile.decode_name(pile)
  return Local.decode_name(pile[index.pile.container].name)
  end

-- -------------------------------------------------------------------------- --
-- gui event

function Stockpile.set_new_uid(pile, old_uid, new_uid)
  Savedata.stockpiles[assert(old_uid)] = nil
  Savedata.stockpiles[assert(new_uid)] = pile
  -- print(old_uid, new_uid)
  end


function Stockpile.set_logistic_mode(pile, pdata, logistic_mode)
  local m,w,h = pile:decode_name()
  if (m ~= logistic_mode) then
    local old_container = pile[index.pile.container]
    local old_uid       = old_container.unit_number
    --
    local new_container = old_container.surface.create_entity{
      name = Local.encode_name(logistic_mode, w, h),
      position = old_container.position,
      force = old_container.force,
      fast_replace = true,
      player = pdata.p,
      create_build_effect_smoke = false,
      }
    pile[index.pile.container] = new_container
    pile:set_new_uid(old_uid, new_container.unit_number)
    InfinityTicker.cache_inventory(pile)
    end
  end
  
  
  
  
function Stockpile.get_inventory(pile)
  return pile[index.pile.container].get_inventory(defines.inventory.chest) end
  
function Stockpile.get_infinity_half_slot_count(pile)
  return math.floor(#pile:get_inventory() / 2) end
  
function Stockpile.can_set_infinity_filter(pile)
  local infinity = pile[index.pile.infinity]
  return (nil == infinity) or (0 == infinity[index.infinity.stored_count]) end
  
function Stockpile.set_infinity_filter(pile, pdata, item_name)
  --
  if not pile:can_set_infinity_filter() then
    Player.notify(pdata.p, 'You must first remove all stored items.')
  --
  else
    local item_data = infinity_items[item_name]
    --
    if item_name == nil then
      pile[index.pile.infinity] = nil
      InfinityTicker.remove_pile(pile)
      Player.notify(pdata.p, 'Filter removed.')
    --
    elseif item_data == nil then
      Player.notify(pdata.p, 'That item can not be set as infinity filter.')
    --
    else
      Player.notify(pdata.p, 'Filter set!')
      local infinity = Table.set(pile, {index.pile.infinity}, {}) --overwrite old!
      --
      infinity[index.infinity.simple_stack] = {name = item_name, count = nil}
      infinity[index.infinity.stored_count] = 0
      infinity[index.infinity.half_count  ]
        = pile:get_infinity_half_slot_count() * item_data.stack_size
      infinity[index.infinity.total_count ] = 0 -- updated in on_tick
      infinity[index.infinity.render_id   ] = nil
      --
      -- infinity[index.infinity.inventory]
        -- = pile:get_inventory()
      -- InfinityTicker.cache_inventory(pile)
      --
      InfinityTicker.add_pile(pile)
      end
    end
  end
  
function Stockpile.get_infinity_filter(pile)
  local infinity = pile[index.pile.infinity]
  return infinity and infinity[index.infinity.simple_stack].name or nil
  end
  
  
-- -------------------------------------------------------------------------- --
-- settings paste

function Stockpile.paste_settings(pile, source, pdata)
  pile:set_logistic_mode(pdata, (source:decode_name()))
  if source[index.pile.infinity] then
    pile:set_infinity_filter(
      pdata, source[index.pile.infinity][index.infinity.simple_stack].name
      )
    end
  end



-- -------------------------------------------------------------------------- --
-- DRAFT
  
  
do
  local valid_item_names = Cache.AutoCache(function(r)
    for name in pairs(game.get_filtered_item_prototypes(
      const.stockpile.infinity.ItemPrototypeFilter
      )) do r[name] = true end
    end)

function Stockpile.repair_infinity(pile, name)
  

  if (not name) and (not pile.infinity) then return end
  end
  end
  
-- AUTHORITY for stockpile savedata format.
function Stockpile.repair_entity(entity)
  local uid  = entity.unit_number
  local name = entity.name
  local pile = Table.sget(Savedata.stockpiles, {uid}, {})
  local m,w,h = Local.decode_name(name)
  --
  Stockpile.destroy_renders(pile)
  Table.clear(pile, {
    'infinity', -- internal data
    'visual_mode', -- user settings
    })
  --
  Stockpile.repair_infinity(pile)
  
  --
  Stockpile.create_renders(pile)
  
  end

function Stockpile.rescan_surfaces()
  for _, surface in pairs(game.surfaces) do
    for _, entity in pairs(surface.find_entities_filtered{
      -- need confirmation: does adding type make it faster?
      type = {'container', 'logistic-container'},
      name = const.stockpile.names_array,
      })
    do
      Stockpile.repair_entity(entity)
      end
    end
  end
  
  
function Stockpile.full_savedata_repair()
  Table.clear(Savedata, Table.keys(SavedataDefaults))
  Table.clear(Savedata.players)
  Table.clear(Savedata.ticked_arrays)
  --
  StockpileGui.destroy_all()
  --
  Stockpile.rescan_surfaces()
  Stockpile.rebuild_ticked_arrays()
  end

  
  
  
  
  
return Stockpile