﻿-- (c) eradicator a.k.a lossycrypt, 2017-2021, not seperately licensable
-- -------------------------------------------------------------------------- --

--[[ Notes:
  ]]

--[[ Annecdotes:
  ]]

--[[ Future:
  ]]
  
--[[ Todo:
  ]]
  
-- -------------------------------------------------------------------------- --
-- Built-In                                                                   --
-- -------------------------------------------------------------------------- --
local elroot = (pcall(require,'erlib/empty')) and '' or '__eradicators-library__/'
local say,warn,err,elreq,flag,ercfg=table.unpack(require(elroot..'erlib/shared'))

-- -------------------------------------------------------------------------- --
-- Eradicators Library                                                        --
-- (Factorio does not allow runtime require!)                                 --
-- -------------------------------------------------------------------------- --
local log         = elreq('erlib/lua/Log'          )().Logger  'stockpile-2-gui'
-- local stop        = elreq('erlib/lua/Error'        )().Stopper 'template'
-- local assertify   = elreq('erlib/lua/Error'        )().Asserter(stop)

-- local Verificate  = elreq('erlib/lua/Verificate'   )()
-- local verify      = Verificate.verify
-- local isType      = Verificate.isType

local Table       = elreq('erlib/lua/Table'        )()
-- local Array       = elreq('erlib/lua/Array'        )()
-- local Set         = elreq('erlib/lua/Set'          )()
-- local Filter      = elreq('erlib/lua/Filter'       )()
-- local Vector      = elreq('erlib/lua/Vector'       )()
local L           = elreq('erlib/lua/Lambda'       )()
local Class       = elreq('erlib/lua/Class'        )()

-- local ntuples     = elreq('erlib/lua/Iter/ntuples' )()
-- local dpairs      = elreq('erlib/lua/Iter/dpairs'  )()
-- local sriapi      = elreq('erlib/lua/Iter/sriapi'  )()

-- local Setting     = elreq('erlib/factorio/Setting'   )()
-- local Player      = elreq('erlib/factorio/Player'    )()
-- local getp        = Player.get_event_player
local Gui         = elreq('erlib/factorio/Gui'       )()

-- -------------------------------------------------------------------------- --
-- Constants                                                                  --
-- -------------------------------------------------------------------------- --
local script = EventManager .get_managed_script    'stockpile-2'
local import = PluginManager.make_relative_require 'stockpile-2'
local const  = import '/const'
local index  = const.index
local Local  = const.Local

-- -------------------------------------------------------------------------- --
-- Module                                                                     --
-- -------------------------------------------------------------------------- --
-- local This = {}

-- -------------------------------------------------------------------------- --
-- Local Library                                                              --
-- -------------------------------------------------------------------------- --

-- -------------------------------------------------------------------------- --
-- Savedata                                                                   --
-- -------------------------------------------------------------------------- --
-- local Savedata
-- local SavedataDefaults = {players = {}}
-- PluginManager.manage_savedata  ('template', function(_) Savedata = _ end, SavedataDefaults)
-- PluginManager.manage_garbage   ('template')
-- PluginManager.classify_savedata('template', {
-- 
--   init_pdata = function(self, pindex)
--     return Table.set(self.players, {assert(pindex)}, {
--       p = game.players[pindex],
--       })
--     end,
-- 
--   get_pdata = function(self, e, pindex)
--     return assert(self.players[pindex or e.player_index])
--     end,
-- 
--   sget_pdata = function(self, e, pindex)
--     local pdata = self.players[pindex or e.player_index]
--             or self:init_pdata(pindex or e.player_index)
--     return pdata, pdata.p end,
-- 
--   del_pdata = function(self, e, pindex)
--     self.players[pindex or e.player_index] = nil
--     end,
--   
--   })
  
-- -------------------------------------------------------------------------- --
-- Events                                                                     --
-- -------------------------------------------------------------------------- --

-- -------------------------------------------------------------------------- --
-- MOVE TO ERLIB -> Gui.make_window()
  
local GuiMakeWindow
do 
  local sidepanel_theme = {
    ['anchor_frame'] = {
      'vertical_frame', 'window_anchor',
      style = 'inset_frame_container_frame',
      -- style = 'outer_frame',
      -- style = 'inner_frame_in_outer_frame',
      -- styler = {vertically_stretchable = true},
      },
     
    ['frame_title_flow'] = {
      'horizontal_flow',
      styler = {bottom_margin = -8}
      },

    ['frame_title_label'] = {
      'label', 'window_title',
       style = 'frame_title',
       ignored_by_interaction = true,
      },
    ['frame_drag_handle'] = {
      'empty-widget', 'window_drag_handle',
      style  = 'draggable_space_header',
      styler = {h = 24, horizontally_stretchable = true, right_margin = 4},
      ignored_by_interaction = true,
      },
    ['frame_close_button'] = {
      'sprite-button', 'window_close_button',
      style               = 'frame_action_button' ,
      sprite              = 'utility/close_white' ,
      hovered_sprite      = 'utility/close_black' ,
      clicked_sprite      = 'utility/close_black' ,
      mouse_button_filter = {'left'}              ,
      },
      
    ['content_frame'] = {
      'vertical_frame',
      style  = 'inside_shallow_frame',
      -- style  = 'inside_shallow_frame_with_padding',
      -- style  = 'entity_frame',
      styler = {use_header_filler = false, vertically_stretchable = true, padding = 4}
      },
      
    ['content_scroll_pane'] = {
      'scroll-pane', 'window_content_pane',
      direction = 'vertical',
      -- vertical_scroll_policy = "auto-and-reserve-space",
      vertical_scroll_policy = "always",
      -- style = 'filter_scroll_pane',
      -- style = 'inventory_scroll_pane',
      style = 'scroll_pane_under_subheader',
      styler = {left_padding = 0, margin = 0, vertically_stretchable = true, horizontally_stretchable = true},
      },
    
    }
    
  local sidepanel_inner_layout = { {
      {'frame_title_flow' }, {
        {'frame_title_label'},
        {'frame_drag_handle'},
        {'frame_close_button'},
        },
      {'content_frame'},{
        {'content_scroll_pane'},
        },
      },
    }

  local constructor = Gui.constructioneer(sidepanel_theme)
  
  local fill = constructor(sidepanel_inner_layout)
    
  -- @tparam string root Name of one of the lua root elements
  function GuiMakeWindow(p, root_type, opts)
    opts = opts or {}
    local window_anchor = constructor{{
      'anchor_frame',
      styler = {opts.anchor_width},
      anchor =  opts.anchor_spec  ,
      name   =  opts.anchor_name  ,
      }}(p.gui[root_type], true)
    local r = fill(window_anchor, false)
    r.window_anchor = window_anchor
    r.window_title.caption = opts.window_title
    return r end
  end
  
  
-- -------------------------------------------------------------------------- --
-- sidepanel layout
  
local content_theme = {
  ['bordered_sub_frame'  ] = {
    'vertical_frame',
    style  = 'bordered_frame',
    styler = {horizontally_stretchable = true, margin = {2,4,2,4}},
    },
  ['slot_button'] = {
    'sprite-button',
    style = 'slot_button',
    -- style = 'slot_sized_button',
    -- style = 'slot_sized_button_green',
    mouse_button_filter = {'left'},
    },
  }
  
  
local content_layout = {{
      
  {'bordered_sub_frame'},{
    {'label', caption = {'gui-control-behavior.mode-of-operation'}},
    {'table', 'logistic_mode_table',  style = 'slot_table', column_count = 3}, {
      Table.rep( {'slot_button'}, 6, {
        sprite = {
          'entity/steel-chest',
          'entity/logistic-chest-passive-provider',
          'entity/logistic-chest-active-provider' ,
          'entity/logistic-chest-storage'         ,
          'entity/logistic-chest-buffer'          ,
          'entity/logistic-chest-requester'       ,
          },
          
        -- sprite = Table.map(const.stockpile.logistic_modes, function(v) return v.sprite end, {})
        -- sprite = Table.map (const.stockpile.logistic_modes, L['v -> v.sprite'], {}),
        sprite = Table.map(Table.values(const.stockpile.logistic_modes), L['v -> v.sprite'], {}),
        name   = Table.keys(const.stockpile.logistic_modes),

          
        -- name = {
          -- 'container', 'passive-provider', 'active-provider',
          -- 'storage', 'buffer', 'requester'
          -- },
        style = {
            -- 'slot',
            'slot_button',
            'slot_button',
            'slot_sized_button_green',
            'slot_button',
            -- 'slot_sized_button',
            'slot_button',
            'slot_button',
            'transparent_slot',
            'tool_button_blue',
            },
        tags = Table.rep(
          {module_name = 'er:stockpile-2', method_name = 'set_logistic_mode'}, 6
          ),
          -- tags = Table.rep({},6, {logistic_mode = {
            -- nil,
            -- 'passive-provider',
            -- 'active-provider',
            -- 'storage',
            -- 'buffer',
            -- 'requester',
            -- }}),
          -- tooltip = {
            -- nil,
            -- 'passive-provider',
            -- 'active-provider',
            -- 'storage',
            -- 'buffer',
            -- 'requester',
            -- },
          }
        )
      
      
      },
    },

  {'bordered_sub_frame'},{
    {'label', caption = {'description.infinity-filter'}},
    -- {'slot_button', style = 'inventory_slot'},
    {'choose-elem-button', 'infinity_filter',
      style = 'inventory_slot',
      elem_type = 'item',
      elem_filters = const.stockpile.infinity.ItemPrototypeFilter,
      tags = {module_name = 'er:stockpile-2', method_name = 'set_infinity_filter'},
      
      },
    },

  {'bordered_sub_frame'},{
    -- For in/out-putting item-with-tags.
    -- Might be nicer to keep that feature semi-secret by
    -- including it in the infinity filter button.
    {'label', caption = 'Input'},
    {'button', style = 'inventory_slot'},
    },

  {'bordered_sub_frame'},{
    {'label', caption = 'Visualization Mode'},
    },

  {'bordered_sub_frame'},{
    {'label', caption = 'Utility'},
    {'button', caption = 'Sort Inventory'},
    {'button', caption = 'Pick up pile'},
    },

  }}
  

-- -------------------------------------------------------------------------- --
-- class
  
local StockpileGui = Class.SimpleClass(
  --
  function(pdata)
    local gui = pdata.gui or {pdata = pdata, p = pdata.p}
    pdata.gui = gui
    return gui end,
  --
  function(gui)
    if flag.IS_DEV_MODE then
      -- gui:destroy()
      end
    if not (gui.window_anchor and gui.window_anchor.valid) then
      gui:repair()
      -- gui:destroy() -- robust against Savedata corruption!
      -- gui:make_empty_sidepanel()
      -- gui:fill_sidepanel()
      -- gui:update_sidepanel(nil) -- can't update without mode
      end
    end
  )
  
-- -------------------------------------------------------------------------- --
-- create / destroy
  
-- function StockpileGui:get_anchor()
  -- local anchor = self.p.gui.relative[const.gui.name.anchor]
  -- if not anchor then self:reset() end
  -- end
  
function StockpileGui.repair(gui)
  log:debug('repairing gui')
  gui:destroy() -- robust against Savedata corruption!
  Table.clear(gui, {'pdata', 'p'})
  --
  for k,v in pairs(gui) do
    if type(v) == 'table' and v.object_name == 'LuaGuiElement' then
      Gui.destroy(v)
      gui[k] = nil
      end
    end
  --
  gui:make_empty_sidepanel()
  gui:fill_sidepanel()  
  -- print(serpent.block(gui))
  end
  
function StockpileGui.destroy(gui)
  log:debug('destroy(window_anchor)')
  local root = gui.p.gui.relative
  Gui.destroy(root[const.gui.name.window_anchor])
  end

function StockpileGui:make_empty_sidepanel()
  -- error(serpent.block(const.name.entities_all))
  
  local r = GuiMakeWindow(self.p, 'relative', {
    anchor_name  = const.gui.name.window_anchor,
    window_title = {'gui-menu.settings'},
    anchor_width = 200,
    anchor_spec  = {
      gui      = defines.relative_gui_type.container_gui,
      position = defines.relative_gui_position.left     ,
      names    = const.stockpile.names_array     ,
      },
    })
  
  
  Table.smerge(self, r)
  end
  
function StockpileGui:fill_sidepanel()
  local r = Gui.constructioneer(content_theme)(content_layout)(self.window_content_pane, false)
  
  Table.smerge(self, r)
  end
  
  
-- local function sprite2mode(sprite_path)
  -- local mode, count = sprite_path:gsub('entity/logistic%-chest%-', '')
  -- return (count > 0) 
     -- and mode
      -- or assert(sprite_path == 'entity/steel-chest' and 'container')
  -- end
  
  
-- -------------------------------------------------------------------------- --
-- update
  
function StockpileGui:update_sidepanel(pile)
  
  -- logistic_mode
  local logistic_mode = pile:decode_name()
  local tbl = self.logistic_mode_table
  for mode in pairs(const.stockpile.logistic_modes) do
    tbl[mode].style = 'slot_button'
    end
  tbl[logistic_mode].style = 'slot_sized_button_green'

  -- infinity_filter
  self.infinity_filter.elem_value = pile:get_infinity_filter()
  

  end
  
  
-- -------------------------------------------------------------------------- --
-- named methods (events)

function StockpileGui:set_logistic_mode(e)
  e.pile:set_logistic_mode(self.pdata, e.element.name)
  self.pdata.p.opened = e.pile[index.pile.container]
  end

function StockpileGui:set_infinity_filter(e)
  if e.name == defines.events.on_gui_elem_changed then
    e.pile:set_infinity_filter(self.pdata, e.element.elem_value)
    self:update_sidepanel(e.pile)
  elseif e.name == defines.events.on_gui_click then
    -- future: read memory element etc.
    -- e.pile:try_import_item_content(self.pdata, self.pdata.p.cursor_stack)
    end
  end

  
  
return StockpileGui